#ifndef SERIALINTERFACE_H
#define SERIALINTERFACE_H

#include "AbstractInterface.h"
#include <iostream>
#include "BinaryLogger.h"


class SerialInterface : public AbstractInterface {
public:
    SerialInterface(const char *device, const unsigned int bitrate);
    virtual ~SerialInterface();

    virtual int open();
    virtual void close();
    virtual int read( unsigned char *, unsigned int );
    virtual int write( unsigned char *, unsigned int );

    virtual std::string toString() const;

    void startLogging(std::string file);

private:
    const char *device;
    unsigned int bitrate;
    int fd;
    BinaryLogger* log;
};

#endif // SERIALINTERFACE_H
