#ifndef WEISSHAPTICSENSOR_H
#define WEISSHAPTICSENSOR_H

#include <Core/core/services/tasks/RunningTask.h>
#include <Core/core/system/ImportExportComponent.h>
#include "SerialInterface.h"
#include "TactileSensor.h"
#include <RobotAPI/interface/units/HapticUnit.h>
#include <Core/util/variants/eigen3/VariantObjectFactories.h>

namespace armarx
{
    class WeissHapticSensor : public Logging
    {
    public:
        WeissHapticSensor(std::string device);

        void connect();
        void disconnect();

        void setListenerPrx(HapticUnitListenerPrx listenerPrx);
        void startSampling();

    private:
        RunningTask<WeissHapticSensor>::pointer_type sensorTask;
        void readAndReportSensorValues();
        std::string device;
        boost::shared_ptr<SerialInterface> interface;
        boost::shared_ptr<TactileSensor> sensor;
        bool connected;
        string tag;
        tac_matrix_info_t mi;
        HapticUnitListenerPrx listenerPrx;
    };
}

#endif
